<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <header-circle-container>
            <div
                class="mt-2 mb-2"
            >
                <img
                    :src="'/img/logo.png'"
                    class="mx-auto w-24"
                />
            </div>
            <div
                class="flex justify-start space-x-4 sm:space-x-2 mb-3 py-2 overflow-x-scroll"
            >
                <a
                    href="javascript:"
                    class="capitalize px-4 py-2 rounded-full sm:text-xs"
                    :class="{
                        'bg-white border-2 border-neutral text-neutral': tab === 'current',
                        'bg-neutral border-2 border-white text-white': tab !== 'current'
                    }"
                    @click="tab = 'current'"
                >
                    {{ $t('current') }}
                </a>
                <a
                    href="javascript:"
                    class="capitalize px-4 py-2 rounded-full sm:text-xs"
                    :class="{
                        'bg-white border-2 border-neutral text-neutral': tab === 'existing',
                        'bg-neutral border-2 border-white text-white': tab !== 'existing'
                    }"
                    @click="tab = 'existing'"
                >
                    {{ $t('closed') }}
                </a>
            </div>
        </header-circle-container>
        <div
            class="flex flex-col space-y-4 px-4 my-4 w-full"
        >
            <template
                v-if="tab === 'current'"
            >
                <div
                    class="flex flex-col space-y-2"
                >
                    <div
                        class="font-black text-lg uppercase"
                    >
                        {{ $t('assured_funds') }}
                    </div>
                    <div
                        v-if="assuredFunds && assuredFunds.length"
                        class="flex flex-col space-y-2"
                    >
                        <custom-card
                            v-for="assuredFund in assuredFunds"
                            :key="assuredFund.id"
                            class="cursor-pointer"
                            @click="$router.push({name: 'user.portfolio.fund.home', params: { code: assuredFund.code }})"
                        >
                            <div
                                class="flex justify-start space-x-3"
                            >
                                <div
                                    class="place-self-center items-center self-center w-12"
                                >
                                    <img
                                        :src="assuredFund.category_icon"
                                        class="w-full"
                                    />
                                </div>
                                <div class="flex-1">
                                    <div
                                        class="font-black"
                                    >
                                        {{ assuredFund.plan_name }}
                                    </div>
                                    <div
                                        class="font-bold font-mono"
                                    >
                                        <div
                                            v-if="assuredFund.total_earning > 0"
                                            class="text-green-500"
                                        >
                                            $ {{ $helper.fundFormat(assuredFund.total_earning) }}
                                        </div>
                                        <div
                                            v-else-if="assuredFund.total_earning < 0"
                                            class="text-red-500"
                                        >
                                            $ {{ $helper.fundFormat(assuredFund.total_earning) }}
                                        </div>
                                        <div
                                            v-else
                                        >
                                            $ {{ $helper.fundFormat(assuredFund.total_earning) }}
                                        </div>
                                    </div>
                                    <div
                                        class="text-xs"
                                    >
                                        {{ $t('ongoing_funds') }}: {{ $helper.fundFormat(assuredFund.ongoing, 0)}}
                                    </div>
                                </div>
                                <div
                                    class="font-black w-auto flex flex-col self-center items-center place-self-center"
                                    :class="{
                                    'text-red-500': assuredFund.win_loss_percentage < 0,
                                    'text-green-500': assuredFund.win_loss_percentage > 0,
                                }"
                                >
                                    <font-awesome-icon
                                        v-if="assuredFund.win_loss_percentage < 0"
                                        icon="fa-solid fa-caret-down"
                                        size="2x"
                                    />
                                    <font-awesome-icon
                                        v-else-if="assuredFund.win_loss_percentage > 0"
                                        icon="fa-solid fa-caret-up"
                                        size="2x"
                                    />
                                    <div
                                        v-if="assuredFund.win_loss_percentage < 0"
                                        class="leading-tight"
                                    >
                                        {{ $helper.fundFormat(assuredFund.win_loss_percentage) }}%
                                    </div>
                                    <div
                                        v-else-if="assuredFund.win_loss_percentage > 0"
                                        class="leading-tight"
                                    >
                                        +{{ $helper.fundFormat(assuredFund.win_loss_percentage) }}%
                                    </div>
                                    <div
                                        v-else
                                        class="leading-tight"
                                    >
                                        0.00%
                                    </div>
                                </div>
                            </div>
                        </custom-card>
                    </div>
                </div>
                <div
                    class="flex flex-col space-y-2"
                >
                    <div
                        class="font-black text-lg uppercase"
                    >
                        {{ $t('structured_funds') }}
                    </div>
                    <div
                        v-if="structuredFunds && structuredFunds.length"
                        class="flex flex-col space-y-2"
                    >
                        <custom-card
                            v-for="structuredFund in structuredFunds"
                            :key="structuredFund.id"
                            class="cursor-pointer"
                            @click="$router.push({name: 'user.portfolio.fund.home', params: { code: structuredFund.code }})"
                        >
                            <div
                                class="flex justify-start space-x-3"
                            >
                                <div
                                    class="place-self-center items-center self-center w-12"
                                >
                                    <img
                                        :src="structuredFund.category_icon"
                                        class="w-full"
                                    />
                                </div>
                                <div class="flex-1">
                                    <div
                                        class="font-black"
                                    >
                                        {{ structuredFund.plan_name }}
                                    </div>
                                    <div
                                        class="font-bold font-mono"
                                    >
                                        <div
                                            v-if="structuredFund.total_earning > 0"
                                            class="text-green-500"
                                        >
                                            $ {{ $helper.fundFormat(structuredFund.total_earning) }}
                                        </div>
                                        <div
                                            v-else-if="structuredFund.total_earning < 0"
                                            class="text-red-500"
                                        >
                                            $ {{ $helper.fundFormat(structuredFund.total_earning) }}
                                        </div>
                                        <div
                                            v-else
                                        >
                                            $ {{ $helper.fundFormat(structuredFund.total_earning) }}
                                        </div>
                                    </div>
                                    <div
                                        class="text-xs"
                                    >
                                        {{ $t('ongoing_funds') }}: {{ $helper.fundFormat(structuredFund.ongoing, 0)}}
                                    </div>
                                </div>
                                <div
                                    class="font-black w-auto flex flex-col self-center items-center place-self-center"
                                    :class="{
                                        'text-red-500': structuredFund.win_loss_percentage < 0,
                                        'text-green-500': structuredFund.win_loss_percentage > 0,
                                    }"
                                >
                                    <font-awesome-icon
                                        v-if="structuredFund.win_loss_percentage < 0"
                                        icon="fa-solid fa-caret-down"
                                        size="2x"
                                    />
                                    <font-awesome-icon
                                        v-else-if="structuredFund.win_loss_percentage > 0"
                                        icon="fa-solid fa-caret-up"
                                        size="2x"
                                    />
                                    <div
                                        v-if="structuredFund.win_loss_percentage < 0"
                                        class="leading-tight"
                                    >
                                        {{ $helper.fundFormat(structuredFund.win_loss_percentage) }}%
                                    </div>
                                    <div
                                        v-else-if="structuredFund.win_loss_percentage > 0"
                                        class="leading-tight"
                                    >
                                        +{{ $helper.fundFormat(structuredFund.win_loss_percentage) }}%
                                    </div>
                                    <div
                                        v-else
                                        class="leading-tight"
                                    >
                                        0.00%
                                    </div>
                                </div>
                            </div>
                        </custom-card>
                    </div>
                </div>
            </template>
            <template
                v-else-if="tab === 'existing'"
            >
                <div
                    class="flex flex-col space-y-2"
                >
                    <div
                        class="font-black text-lg uppercase"
                    >
                        {{ $t('assured_funds') }}
                    </div>
                    <div
                        class="flex flex-col space-y-2"
                    >
                        <custom-card
                            v-for="assuredFund in existingAssuredFunds"
                            :key="assuredFund.id"
                            class="cursor-pointer"
                            @click="$router.push({name: 'user.portfolio.fund.existing_contract', params: {code: assuredFund.code}})"
                        >
                            <div
                                class="flex justify-start space-x-3"
                            >
                                <div
                                    class="place-self-center items-center self-center w-12"
                                >
                                    <img
                                        :src="assuredFund.category_icon"
                                        class="w-full"
                                    />
                                </div>
                                <div class="flex-1">
                                    <div
                                        class="font-black"
                                    >
                                        {{ assuredFund.plan_name }}
                                    </div>
                                    <div
                                        class="font-bold font-mono"
                                    >
                                        <div
                                            class="text-green-500"
                                        >
                                            $ {{ $helper.fundFormat(assuredFund.total_earning) }}
                                        </div>
                                    </div>
                                    <div
                                        class="text-xs"
                                    >
                                        {{ $t('ongoing_funds') }}: {{ $helper.fundFormat(0, 0)}}
                                    </div>
                                </div>
                                <div
                                    class="font-black w-auto flex flex-col self-center items-center place-self-center text-green-500"
                                >
                                    <font-awesome-icon
                                        icon="fa-solid fa-caret-up"
                                        size="2x"
                                    />
                                    <div
                                        class="leading-tight"
                                    >
                                        +{{ $helper.fundFormat(assuredFund.win_loss_percentage, 0) }}%
                                    </div>
                                </div>
                            </div>
                        </custom-card>
                    </div>
                </div>
                <div
                    class="flex flex-col space-y-2"
                >
                    <div
                        class="font-black text-lg uppercase"
                    >
                        {{ $t('structured_funds') }}
                    </div>
                    <div
                        v-if="structuredFunds && existingStructuredFunds.length"
                        class="flex flex-col space-y-2"
                    >
                        <custom-card
                            v-for="structuredFund in existingStructuredFunds"
                            :key="structuredFund.id"
                            class="cursor-pointer"
                            @click="$router.push({name: 'user.portfolio.fund.existing_contract', params: {code: structuredFund.code}})"
                        >
                            <div
                                class="flex justify-start space-x-3"
                            >
                                <div
                                    class="place-self-center items-center self-center w-12"
                                >
                                    <img
                                        :src="structuredFund.category_icon"
                                        class="w-full"
                                    />
                                </div>
                                <div class="flex-1">
                                    <div
                                        class="font-black"
                                    >
                                        {{ structuredFund.plan_name }}
                                    </div>
                                    <div
                                        class="font-bold font-mono"
                                    >
                                        <div
                                            class="text-green-500"
                                        >
                                            $ {{ $helper.fundFormat(structuredFund.total_earning) }}
                                        </div>
                                    </div>
                                    <div
                                        class="text-xs"
                                    >
                                        {{ $t('ongoing_funds') }}: 0
                                    </div>
                                </div>
                                <div
                                    class="font-black w-auto flex flex-col self-center items-center place-self-center text-green-500"
                                >
                                    <font-awesome-icon
                                        icon="fa-solid fa-caret-up"
                                        size="2x"
                                    />
                                    <div
                                        class="leading-tight"
                                    >
                                        +{{ $helper.fundFormat(structuredFund.win_loss_percentage, 0) }}%
                                    </div>
                                </div>
                            </div>
                        </custom-card>
                    </div>
                </div>
            </template>
        </div>
    </div>
</template>

<script setup>
import {computed, onMounted, ref, watch} from "vue";
import CustomCard from "~/components/custom-card.vue";
import HeaderCircleContainer from "~/components/header-circle-container.vue";
import {FontAwesomeIcon} from "@fortawesome/vue-fontawesome";
import axios from "axios";
import BigNumber from "bignumber.js";
import {useSettingStore} from "~/stores/setting.js";

const $settingStore = useSettingStore();
const investments = ref([]);
const existingInvestments = ref({});
const existingInvestmentHistories = ref({});
const pageReady = ref(false);
const tab = ref('current');

const settings = computed(() => {
    return $settingStore.settings;
});

watch(tab, async (newValue) => {
    if (newValue === 'existing') {
        try {
            const data = await axios.post('/portfolio/fetch/existing');
            if (data.investments) {
                existingInvestments.value = data.investments;
            }
            if (data.histories) {
                existingInvestmentHistories.value = data.histories;
            }
        } catch (e) {
            console.log(e);
        }
    }
});

onMounted(async () => {
    try {
        const data = await axios.post('/portfolio/fetch');

        if (data.model) {
            investments.value = data.model;
        }

        await $settingStore.fetchSettings();

        pageReady.value = true;
    } catch (e) {
        console.log(e);
    }
});

const assuredFunds = computed(() => {
    let p = 'assured';
    return settings.value.plans.filter(plan => {
        return plan.setting && plan.setting.plan_type === p;
    }).map(plan => {
        let purchased = investments.value && investments.value.filter(r => {
            return r.code === plan.code;
        }) || null;
        let obj = {...plan};
        if (purchased) {
            let temp = {
                ongoing: 0,
                total_investment: 0,
                total_balance: 0,
            };
            purchased.forEach(row => {
                if (parseInt(row.status) !== 1) {
                    temp.ongoing++;
                    temp.total_investment += parseFloat(row.current_balance);
                    temp.total_balance += parseFloat(parseFloat(row.current_balance) + parseFloat(row.roi_balance));
                }
            });

            temp.total_earning = new BigNumber(temp.total_balance).minus(new BigNumber(temp.total_investment)).toNumber();
            temp.win_loss_percentage = new BigNumber(temp.total_earning).div(new BigNumber(temp.total_investment)).times(100).toNumber();
            obj = {...obj, ...temp};
        }

        return obj;
    }) || [];
});
const structuredFunds = computed(() => {
    let p = 'structured';
    return settings.value.plans.filter(plan => {
        return plan.setting && plan.setting.plan_type === p;
    }).map(plan => {
        let purchased = investments.value && investments.value.filter(r => {
            return r.code === plan.code;
        }) || null;
        let obj = {...plan};
        if (purchased) {
            let temp = {
                ongoing: 0,
                total_investment: 0,
                total_balance: 0,
            };
            purchased.forEach(row => {
                temp.ongoing++;
                temp.total_investment += parseFloat(row.current_balance);
                temp.total_balance += parseFloat(parseFloat(row.current_balance) + parseFloat(row.total_roi));
            });

            temp.total_earning = new BigNumber(temp.total_balance).minus(new BigNumber(temp.total_investment)).toNumber();
            temp.win_loss_percentage = new BigNumber(temp.total_earning).div(new BigNumber(temp.total_investment)).times(100).toNumber();
            obj = {...obj, ...temp};
        }
        return obj;
    }) || [];
});

const existingAssuredFunds = computed(() => {
    return settings.value.plans.filter(plan => {
        return plan.setting && plan.setting.plan_type === 'assured' && plan.code === 'AASF';
    }).map(plan => {
        let obj = {...plan};
        let invested = existingInvestments.value[plan.code];
        let balance = invested;

        obj.total_earning = 0;
        obj.win_loss_percentage = 0;
        if (typeof existingInvestmentHistories.value[plan.code] !== 'undefined') {
            Object.keys(existingInvestmentHistories.value[plan.code]).forEach(key => {
                balance += (invested / 100) * existingInvestmentHistories.value[plan.code][key];
            });

            obj.total_earning = balance - invested;
            obj.win_loss_percentage = (obj.total_earning / invested) * 100;
        }

        return obj;
    }) || [];
});
const existingStructuredFunds = computed(() => {
    return settings.value.plans.filter(plan => {
        return plan.setting && plan.setting.plan_type === 'structured' && plan.code === 'ASGF';
    }).map(plan => {
        let obj = {...plan};
        let invested = existingInvestments.value[plan.code];
        let balance = invested;

        obj.total_earning = 0;
        obj.win_loss_percentage = 0;
        if (typeof existingInvestmentHistories.value[plan.code] !== 'undefined') {
            Object.keys(existingInvestmentHistories.value[plan.code]).forEach(key => {
                balance += (invested / 100) * existingInvestmentHistories.value[plan.code][key];
            });

            obj.total_earning = balance - invested;
            obj.win_loss_percentage = (obj.total_earning / invested) * 100;
        }

        return obj;
    }) || [];
});
</script>
